<?php
/*
Name: Blogger Beta Import
Version: 0.2
URI: http://www.romantika.name/v2/2006/12/19/import-blogger-beta-to-wordpress/
Description: Import Blogger Beta into WordPress
Author: Ady Romantika (ady@romantika.name)
Author URI: http://www.romantika.name/v2/

TODO
====
1. URL for non blogger commenters ## DONE 2006-12-22 ##

Please read my website for instructions and detailed info.

This script is licensed under GPL v2.

Changelog:
=========
2006-12-22 -	1. added ability to add commentor URL and email since these data can't be obtained from RSS.
				2. added extra checks to terminate script if something fails. No use wasting user time to wait for a broken result.
*/

require_once "./wp-config.php";

// Database connection
$link = mysql_connect(DB_HOST,DB_USER,DB_PASSWORD) or die('ERROR: Connection failed - check configurations.');
if(!mysql_select_db(DB_NAME,$link)) die ('ERROR: Cannot select database.');

if(isset($_POST['blogger']))
{
	/***********************************************************************
	/ POSTS
	/**********************************************************************/
	// Reads XML file into formatted html
	function readXML($xmlFile)
	{
		$xmlParser = xml_parser_create();

		xml_parser_set_option($xmlParser, XML_OPTION_CASE_FOLDING, false);
		xml_set_element_handler($xmlParser, startElement, endElement);
		xml_set_character_data_handler($xmlParser, characterData);

		$fp = fopen($xmlFile, "r");

		while($data = fread($fp, 8192))
		{
			xml_parse($xmlParser, $data, feof($fp));
		}
		xml_parser_free($xmlParser);
	}

	// Sets the current XML element, and pushes itself onto the element hierarchy
	function startElement($parser, $name, $attrs)
	{
		global $currentElements, $itemCount;
		array_push($currentElements, $name);
		if($name == "item"){$itemCount += 1;}
	}

	// Prints XML data; finds highlights and links
	function characterData($parser, $data)
	{
		global $currentElements, $postsArray, $itemCount;

		$currentCount = count($currentElements);
		$parentElement = $currentElements[$currentCount-2];
		$thisElement = $currentElements[$currentCount-1];

		if($parentElement == "item")
		{
			$postsArray[$itemCount-1][$thisElement] .= $data;
		}
	}

	// If the XML element has ended, it is poped off the hierarchy
	function endElement($parser, $name)
	{
		global $currentElements;

		$currentCount = count($currentElements);
		if($currentElements[$currentCount-1] == $name)
		{
			array_pop($currentElements);
		}
	}

	/***********************************************************************
	/ COMMENTS
	/**********************************************************************/
	// Reads XML file into formatted html
	function readCXML($xmlFile)
	{
		$xmlParser = xml_parser_create();

		xml_parser_set_option($xmlParser, XML_OPTION_CASE_FOLDING, false);
		xml_set_element_handler($xmlParser, startCElement, endCElement);
		xml_set_character_data_handler($xmlParser, characterCData);

		$fp = fopen($xmlFile, "r");

		while($data = fread($fp, 8192))
		{
			xml_parse($xmlParser, $data, feof($fp));
		}
		xml_parser_free($xmlParser);
	}

	// Sets the current XML element, and pushes itself onto the element hierarchy
	function startCElement($parser, $name, $attrs)
	{
		global $currentCElements, $itemCCount;
		array_push($currentCElements, $name);
		if($name == "entry"){$itemCCount += 1;}
	}

	// Prints XML data; finds highlights and links
	function characterCData($parser, $data)
	{
		global $currentCElements, $commentsArray, $itemCCount;

		$currentCount = count($currentCElements);
		$parentElement = $currentCElements[$currentCount-2];
		$thisElement = $currentCElements[$currentCount-1];

		if($parentElement == "entry")
		{
			$commentsArray[$itemCCount-1][$thisElement] .= $data;
		}
		if($parentElement == "author")
		{
			$commentsArray[$itemCCount-1][$thisElement] .= $data;
		}
	}

	// If the XML element has ended, it is poped off the hierarchy
	function endCElement($parser, $name)
	{
		global $currentCElements;

		$currentCount = count($currentCElements);
		if($currentCElements[$currentCount-1] == $name)
		{
			array_pop($currentCElements);
		}
	}

	/***********************************************************************
	/ MAIN
	/**********************************************************************/

	// Get general variables
	$basic_url = 'http://'.$_POST['blogger'].'.blogspot.com/feeds/posts/full?alt=rss&max-results=1&start-index=200000';
	$post_url = 'http://'.$_POST['blogger'].'.blogspot.com/feeds/posts/full?alt=rss&max-results=100&start-index=';
	$comment_url = 'http://'.$_POST['blogger'].'.blogspot.com/feeds/XXXXXXXXXXXX/comments/default';

	$file = fopen($basic_url,"r");
	$filedata = fread($file,8192);
	fclose($file);

	// Too lazy to parse XML
	$totalPosts = substr($filedata, strpos($filedata,'<openSearch:totalResults>')+25, strpos($filedata,'</openSearch:totalResults>')-strpos($filedata,'<openSearch:totalResults>')-25);
	$bloggerId = substr($filedata, strpos($filedata,'<atom:id>')+9, strpos($filedata,'</atom:id>')-strpos($filedata,'<atom:id>')-9);
	$bloggerId = preg_replace('/tag:\w+\.\w+\,\d+:blog-/','',$bloggerId);

	echo '<h1>Import Blogger Beta to WordPress 2.0.x</h1>';

	print '<p>Blogger ID: ['.$bloggerId.']</p>';
	print '<p>Number of posts: ['.$totalPosts.']</p>';

	// Look for max post number
	$sql = 'SELECT max(ID) AS max FROM '.$table_prefix.'posts';
	$result = mysql_query($sql) or die('Unable to find max post from database. Script terminated.');
	$dat = mysql_fetch_object($result);

	$nextItem = $dat->max + 1;

	$currentElements = array();
	$postsArray = array();

	$currentCElements = array();
	$commentsArray = array();

	$numLoop = ceil($totalPosts/100);

	for($x=1;$x<=$numLoop;$x++) readXML($post_url.($x*100-99));

	$postsArray = array_reverse($postsArray);

	// Now that we have the data
	for($x=0;$x<$itemCount;$x++)
	{
		unset($itemCCount);
		unset($currentCElements);
		unset($commentsArray);
		$currentCElements = array();
		$commentsArray = array();

		// Get blogpost ID - useful to retrieve comments later
		$postsArray[$x]['blogpost-id'] = substr($postsArray[$x]['guid'],strpos($postsArray[$x]['guid'],'.post-')+6);
		// Debugging display
		print "<br>Post $x read from XML: ".$postsArray[$x]['title']; //." - ".$postsArray[$x]['blogpost-id'];

		// Cleanup of javascript onblur thingies from images
		$postsArray[$x]['description'] = preg_replace('/\sonblur=\"(\w*\{*\}*\s*\.*\(*\)*\;*)*\"/','',$postsArray[$x]['description']);

		// Wed, 13 Dec 2006 15:27:00 +0000
		$datetime = strtotime($postsArray[$x]['pubDate']);
		$postDate = date("Y-m-d H:i:s",$datetime);
		$postDateGMT = gmdate("Y-m-d H:i:s",$datetime);

		// Post ID on WordPress
		$Post_ID = ($nextItem + $x);

		$sql = 'INSERT into '.$table_prefix.'posts(ID, post_category, post_author, post_date, post_date_gmt, post_content, post_title,';
		$sql.= 'post_name) VALUES ';
		$sql.= "(".$Post_ID.",".$_POST['category'].",".$_POST['user'].",'$postDate','$postDateGMT','";
		$sql.= str_replace(array('<br>','<BR>','<br/>','<BR/>','<br />','<BR />'), "\n", addslashes($postsArray[$x]['description']));
		$sql.= "','".addslashes($postsArray[$x]['title'])."','".sanitize_title_with_dashes($postsArray[$x]['title'])."')";
		mysql_query($sql,$link) or die('Error inserting post.');

		mysql_query("insert into ".$table_prefix."post2cat (post_id, category_id) values (".($nextItem + $x).",".$_POST['category'].")",$link) or die('Error relating post to category');

		mysql_query("update ".$table_prefix."categories set category_count = category_count + 1 WHERE cat_ID = ".$_POST['category'], $link) or die('Error incrementing category count');

		// Look for comments based on post ID
		readCXML(str_replace('XXXXXXXXXXXX',$postsArray[$x]['blogpost-id'],$comment_url));

		for($y=0;$y<$itemCCount;$y++)
		{
			$dates = explode('T',$commentsArray[$y]['published']);

			$dd = explode('-',$dates[0]); // directly usable
			$t1 = explode('.',$dates[1]);
			$tt = explode(':',$t1[0]); // usable

			$datetime = mktime($tt[0],$tt[1],$tt[2],$dd[1],$dd[2],$dd[0]);

			$commentDate = date("Y-m-d H:i:s",$datetime);
			$commentDateGMT = gmdate("Y-m-d H:i:s",$datetime);

			$sql = 'INSERT INTO '.$table_prefix.'comments (comment_post_ID, comment_author, comment_author_email,	comment_author_url, comment_date,';
			$sql.= 'comment_date_gmt, comment_content, comment_approved, user_id) VALUES ';
			$sql.= "($Post_ID,'".$commentsArray[$y]['name']."','','','".$commentDate."','".$commentDateGMT."','".addslashes($commentsArray[$y]['content'])."',";
			$sql.= "'1', 0)";
			mysql_query($sql,$link) or die('Error inserting comment.');
			$sql = 'UPDATE '.$table_prefix.'posts SET comment_count = comment_count + 1 WHERE ID = '.$Post_ID;
			mysql_query($sql,$link) or die('Error incrementing comment count in post.');
		}
	}

	echo '<h1>You\'re done!</h1>';
	echo '<h3>However if you want... you can map these comment authors to their website and emails</h3>';

	// Now look for comments author if user wants to
	$sql = 'SELECT comment_author,count(comment_author) AS count FROM '.$table_prefix.'comments GROUP BY comment_author ORDER BY count DESC';
	$result = mysql_query($sql,$link) or die('Error getting comments data');
	$numrows = mysql_num_rows($result);
	echo '<form method="POST" action="">';
	echo '<table border="1">';
	echo '<tr><td>Author</td><td>No of comments</td><td>Email</td><td>Website (please include http://)</td></tr>';
	for($x=0;$x<$numrows;$x++)
	{
		$data = mysql_fetch_object($result);
		echo '<tr>';
		echo '<td>'.$data->comment_author.'</td>';
		echo '<td>'.$data->count.'</td>';
		echo '<td><input type="text" name="email'.$x.'"></td>';
		echo '<td><input type="text" name="website'.$x.'"><input type="hidden" name="author'.$x.'" value="'.$data->comment_author.'"></td>';
		echo '</tr>';
	}
	echo '</table>';
	echo '<input type="hidden" name="commentcount" value="'.$numrows.'">';
	echo '<input type="submit" value="Save">';
	echo '</form>';
	?>
	<hr>By <a href="http://www.romantika.name/v2/">Ady Romantika</a> (Ady at Romantika dot Name)
<?php
}
else if(isset($_POST['email0']))
{
	for($x=0;$x<31;$x++)
	{
		if($_POST['email'.$x] != '' || $_POST['website'.$x] != '')
		{
			$sql = 'UPDATE '.$table_prefix.'comments SET ';
			if($_POST['email'.$x] != '') $sql.= 'comment_author_email = \''.$_POST['email'.$x].'\' ';
			if($_POST['email'.$x] != '' && $_POST['website'.$x] != '') $sql.=',';
			if($_POST['website'.$x] != '') $sql.= 'comment_author_url=\''.$_POST['website'.$x].'\' ';
			$sql.= 'WHERE comment_author = \''.$_POST['author'.$x].'\'';
			mysql_query($sql,$link) or die('Error updating commentor database.');
			echo '<br>Updated author '.$_POST['author'.$x];
		}
	}

	echo '<h1>Now you\'re really done!</h1>';
	?>
	<hr>By <a href="http://www.romantika.name/v2/">Ady Romantika</a> (Ady at Romantika dot Name)
<?php
}
else
{
	$sql = "SELECT ID, user_login, user_nicename FROM ".$table_prefix."users";
	$result1 = mysql_query($sql);
	$sql = "SELECT cat_ID, cat_name FROM ".$table_prefix."categories";
	$result2 = mysql_query($sql);
?>

<html>
	<head>
		<title>Import Blogger Beta to WordPress 2.0.x</title>
	</head>
	<body>
		<h1>Import Blogger Beta to WordPress 2.0.x</h1>

<form method="POST" action="">
Blogger ID: <input type="text" name="blogger">.blogspot.com<br/>
Default User:
<select name="user">
	<?php
		while($userdat = mysql_fetch_object($result1))
		{
			echo '<option value="'.$userdat->ID.'">'.$userdat->user_login.' ('.$userdat->user_nicename.')</option>';
		}
	?>
</select>
Default Category:
<select name="category">
	<?php
		while($catdat = mysql_fetch_object($result2))
		{
			echo '<option value="'.$catdat->cat_ID.'">'.$catdat->cat_name.'</option>';
		}
	?>
</select>
<input type="submit" value="Import">
</form>

<hr>
By <a href="http://www.romantika.name/v2/">Ady Romantika</a> (Ady at Romantika dot Name)

<?php
}
?>